/**
 * mmap örneği
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>

int main(int argc, char *argv[]){

   char  *p;
   int    size;
   int    fd;

   struct stat sbuf;

   fprintf(stdout, "pid %d\n", getpid());

   fd= open("test.file", O_RDWR);

   if ( fd == -1 ){
      perror("open(test.file)");
      return EXIT_FAILURE;
      }

   fprintf(stdout, "fd %d\n", fd);

   if ( fstat(fd, &sbuf) == -1) {
      perror("fstat()");
      return EXIT_FAILURE;
      }

   size= sbuf.st_size;
   fprintf(stdout, "size %d\n", size);

   p= mmap(NULL, size, PROT_WRITE, MAP_SHARED, fd, 0);

   if ( p == MAP_FAILED ){
      perror("mmap()");
      return EXIT_FAILURE;
      }

   fprintf(stdout, "addr %p\n", p);

   // Okunan içieriği tamamen yaz.
   int i;
   for(i= 0; i< size; i++){
      fprintf(stdout, "%c", p[i]);
      }
   fprintf(stdout, "\n");

   // niye strcpy() değil?
   strncpy(p+ 8, "merhaba", 7);

   fprintf(stdout, "bitirmek için bir tuşa basınız,\n");
   getchar();

   if ( munmap(p, size) == -1 ){
      perror("mmap()");
      return EXIT_FAILURE;
      }

   return EXIT_SUCCESS;
}
                                        
