/**
 * prog2.c
 *
 * mmap örneği
 *
 * Bu program dosyayı map eder ve p+8 adresine devamlı olarak
 * 6 karakter yazar.
 *
 * prog3.c programı da yazılan bu ifadeleri düzenli olarak gösterir.
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>

int cont= 1;

void yakala(int sig){
   cont= 0;
}

int main(int argc, char *argv[]){

   char  *p;
   int    size;
   int    fd;

   struct stat sbuf;

   signal(SIGINT, yakala);

   fprintf(stdout, "pid %d\n", getpid());

   fd= open("test.file", O_RDWR);

   if ( fd == -1 ){
      perror("open(test.file)");
      return EXIT_FAILURE;
      }

   fprintf(stdout, "fd %d\n", fd);

   if ( fstat(fd, &sbuf) == -1) {
      perror("fstat()");
      return EXIT_FAILURE;
      }

   size= sbuf.st_size;
   fprintf(stdout, "size %d\n", size);

   p= mmap(NULL, size, PROT_WRITE, MAP_SHARED, fd, 0);

   if ( p == MAP_FAILED ){
      perror("mmap()");
      return EXIT_FAILURE;
      }

   fprintf(stdout, "addr %p\n", p);

   // Okunan içeriği tamamen yaz.
   int i;
   for(i= 0; i< size; i++){
      fprintf(stdout, "%c", p[i]);
      }
   fprintf(stdout, "\n");
   fprintf(stdout, "Crtl+C ile durdur.\n");

   char buf[8];
   for(i= 0; cont; i++){
      snprintf(buf, sizeof(buf), "%07d", i);
      strncpy(p+ 8, buf, 7);
      fprintf(stdout, "yazılan %d\n", i);
      sleep(1);
      }

   if ( munmap(p, size) == -1 ){
      perror("mmap()");
      return EXIT_FAILURE;
      }

   fprintf(stdout, "\nbitti.\n");
   return EXIT_SUCCESS;
}
                                        
