/**
 * prog1.c
 *
 * fd tabanlı zamanlayıcı
 *
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <time.h>
#include <inttypes.h>
#include <errno.h>
#include <string.h>
#include <sys/time.h>
#include <sys/timerfd.h>

void disp_time(int i){

   struct  timeval now;
   gettimeofday(&now, NULL);

   if ( i== 1 ){
      fprintf(stdout, "timer1 ");
      }
      else{
      fprintf(stdout, "  timer2 ");
      }

   fprintf(stdout, "%ld.%03ld\n", now.tv_sec, now.tv_usec/1000);
}

int main(int argc, char *argv[]){

   struct itimerspec new_value;
   fd_set tmpfs;
   fd_set readfs;
   int    max_fd;
   int    res;
   int    fd1;
   int    fd2;

   uint64_t s;

   // 2 saniye sonra başla.
   new_value.it_value.tv_sec = 2;
   new_value.it_value.tv_nsec= 0;

   // Saniyede 2 kez atış yap.
   fd1= timerfd_create(CLOCK_MONOTONIC, TFD_CLOEXEC);

   new_value.it_interval.tv_sec  = 0;
   new_value.it_interval.tv_nsec = 500 * 1000 * 1000;

   timerfd_settime(fd1, 0, &new_value, NULL); // dönüş?

   // Saniyede 4 kez atış yap.
   fd2= timerfd_create(CLOCK_MONOTONIC, TFD_CLOEXEC);

   new_value.it_interval.tv_sec  = 0;
   new_value.it_interval.tv_nsec = 250 * 1000 * 1000;

   timerfd_settime(fd2, 0, &new_value, NULL); 

   // select() alt yapısını kur.

   FD_ZERO(&readfs);
   FD_SET(fd1, &readfs);
   FD_SET(fd2, &readfs);

   max_fd= fd1>fd2 ? fd1:fd2;

   fprintf(stdout, "fd1:%d  fd2:%d  max_fd:%d\n", fd1, fd2, max_fd);

   // select()'e gelen kadar, hiç bir zamanının 
   // ateşlenmediğini kabul ediyoruz.
   //
   for(;;){
      tmpfs= readfs;

      res= select(max_fd+ 1, &tmpfs, NULL, NULL, NULL);

      if (res < 0) {
         perror("select()");
         break;
         }

      // res== 0 olamaz.
      
      if ( FD_ISSET(fd1, &tmpfs) ){
         read(fd1, &s, sizeof(uint64_t)); // dönüş ?
         disp_time(1);
         res--;
         }

      if ( res == 0 ){
         continue;
         }

      if ( FD_ISSET(fd2, &tmpfs) ){
         read(fd2, &s, sizeof(uint64_t));
         disp_time(2);
         }

      } // for;;

   // timerfd_gettime() ile kalan sürei okunabilir.
   // close(fd) ile kapatılır.

   return EXIT_SUCCESS;
}

