/**
 * prog1.c
 *
 * Tüketici.
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>
#include <mqueue.h>
#include <sys/types.h>
#include <sys/time.h>

#define QUE "/test"	

#define DISP_TIME struct timeval t; \
                  gettimeofday(&t, NULL); \
                  fprintf(stdout, "%ld.%06ld: ", t.tv_sec, t.tv_usec)

int main(int argc, char *argv[]){

   struct  mq_attr attr;
   char    buf[256];
   ssize_t n;
   mqd_t   mq;

   fprintf(stdout, "pid %d\n", getpid());

   // attr
   attr.mq_flags  = 0;
   attr.mq_maxmsg = 10;
   attr.mq_msgsize= sizeof(buf)- 1;
   attr.mq_curmsgs= 0;

   // create
   mq= mq_open(QUE, O_CREAT|O_RDONLY, 0644, &attr);

   if ( mq == -1 ){
      perror("mq_open()");
      return EXIT_FAILURE;
      }

   fprintf(stdout, "%s üzerinden mesaj bekliyorum...\n", QUE);

   // recevice forever
   for(;;){

      n= mq_receive(mq, buf, sizeof(buf)- 1, NULL);

      if ( n == - 1){
         perror("mq_receive()");
         break;
         }

      DISP_TIME;

      buf[n]= '\0';
      fprintf(stdout, "%s", buf);

      if ( strcmp(buf, "q") == 0 ){
         break;
         }

      } 

   mq_close(mq);
   mq_unlink(QUE);

   return EXIT_SUCCESS;
}

