/**
 * prog2.c
 *
 * 1. argümanı yavaş yavaş ekrana yazar.
 * Yazılan bigiler diğer proses ile karışmaz.
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <fcntl.h>           
#include <sys/stat.h>    
#include <semaphore.h>
#include <string.h>

#define RND(MIN, MAX) (rand() % (MAX + 1 - MIN)) + MIN

void disp(char *arg){

   char  *p;
   long   t;
   sem_t *sem;

   /* Semafor varsa aç, yoksa yarat. */
   sem= sem_open("/sayici", 
                  O_CREAT,
                  S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP,
                  1
                );

   if (sem == SEM_FAILED) {
      perror("sem_open()");
      exit(EXIT_FAILURE);
      }

   srandom(time(NULL));

   for(;;){

      /* kritik bölge başlangıcı. */

      if ( sem_wait(sem)== -1 ){
         perror("sem_wait()");
         exit(EXIT_FAILURE);
         }

      for(p= arg; *p != '\0'; p++){
         fprintf(stdout, "%c", *p);
         fflush(stdout);
         t= RND(10000, 900000);
         usleep(t);
         }

      if ( sem_post(sem)== -1 ){
         perror("sem_post()");
         exit(EXIT_FAILURE);
         }

      // post/wait arka arkaya olduğu için,
      // race cond. her zaman burası kazanır.
      // Bundan dolayı araya biraz gecikme yok.
      // Pratikte yapılmaz.
      //
      usleep(10); 

      /* kritik bölge bitişi. */
      }
}

int main(int argc, char *argv[]){

   if ( argc > 1 ){
      disp(argv[1]);
      }
      else{
      // Semafor her zaman 1 ile başlamalıdır. 
      //
      int val;
      sem_t *sem;
      sem= sem_open("/sayici", 0);
      sem_getvalue(sem, &val);  // dönüşü ?
      if ( val== 0 ){ 
         sem_post(sem); 
         sem_getvalue(sem, &val);  
         }
      fprintf(stdout, "sem value %d\n", val);
      }

   return EXIT_SUCCESS;
}

