/**
 * prog2.c
 * 
 * Alfabeyi ortak belleğe yaz.
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>       
#include <fcntl.h>         

int main(int argc, char *argv[]){

   char *addr;
   int   fd;
   char  p;
   int   i;

   fd= shm_open("/ortak_bellek", O_RDWR, 0);
   if ( fd == -1 ){
      perror("shm_open()");
      return EXIT_FAILURE;
      }

   addr= mmap(NULL, 1024, PROT_WRITE, MAP_SHARED, fd, 0); 

   if ( addr == MAP_FAILED ){
      perror("mmap()");
      return EXIT_FAILURE;
      }

   // Veriyi ortak alana yaz.
   // Veri sonuna \n yaz.
   //
   i= 0;
   for(p= 'A'; p<= 'Z'; p++){
      addr[i]= p; 
      i++;
      }

   addr[i]= '\n';

   // Sadece fd'yi kapatmak, map alanını serbest bırakmaz.
   // Ortak alanla işimiz kalmadı, kapat.
   //
   if ( munmap(addr, 1024) == -1 ){
      perror("shm_open()");
      return EXIT_FAILURE;
      }

   // fd'yi ayrıca kapat.
   // 
   if ( close(fd) == -1 ){
      perror("shm_open()");
      return EXIT_FAILURE;
      }

   fprintf(stdout, "Alfabe ortak belleğe yazıldı.\n");

   return EXIT_SUCCESS;
}

