/**
 * prog3.c
 *
 * Paylaşılan belleği oku ve harfleri küçülterek ekrana yaz.
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>

#include <sys/mman.h>
#include <sys/stat.h>       
#include <fcntl.h>         

int main(int argc, char *argv[]){

   char *addr;
   int   fd;
   char *p;

   fd= shm_open("/ortak_bellek", O_RDONLY, 0);
   if ( fd == -1 ){
      perror("shm_open()");
      return EXIT_FAILURE;
      }

   addr= mmap(NULL, 1024, PROT_READ, MAP_SHARED, fd, 0); 

   if ( addr == MAP_FAILED ){
      perror("mmap()");
      return EXIT_FAILURE;
      }

   // Veriyi oku.
   //
   for(p= addr; *p != '\n'; p++){
      fprintf(stdout, "%c", tolower(*p));
      }
   fprintf(stdout, "\n");

   // Sadece fd'yi kapatmak, map alanını serbest bırakmaz.
   // Ortak alanla işimiz kalmadı, kapat.
   //
   if ( munmap(addr, 1024) == -1 ){
      perror("shm_open()");
      return EXIT_FAILURE;
      }

   // fd'yi ayrıca kapat.
   // 
   if ( close(fd) == -1 ){
      perror("shm_open()");
      return EXIT_FAILURE;
      }

   fprintf(stdout, "Alfabe ortak bellekten okundu.\n");

   return EXIT_SUCCESS;
}

