/**
 * prog1.c
 *
 * tcp client
 *
 */
#include <stdio.h>

#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <ctype.h>

#include <sys/socket.h>
#include <sys/types.h>
#include <arpa/inet.h> 

int socket_connect(char *remote, char *port){

  struct addrinfo *res;
  struct addrinfo *ressave;
  struct addrinfo  hints;

  int    fd;
  int    n;

  bzero(&hints, sizeof(struct addrinfo));

  hints.ai_family  = AF_UNSPEC;
  hints.ai_socktype= SOCK_STREAM;
  hints.ai_protocol= IPPROTO_TCP;  
  // tcp üzerinden stream yapıyoruz.
                                   // raw'da yapabilirdik.

  n= getaddrinfo(remote, port, &hints, &res);

  if ( n != 0 ){
     printf("error %s:%s %s\n", remote, port, gai_strerror(n));
     return -1;
     }

  ressave= res;

  do{
    fd= socket(res->ai_family, res->ai_socktype, res->ai_protocol);
 
    if ( fd < 0 ){
       continue;  // ignore this returned ip addr.
       }
  
   if ( connect(fd, res->ai_addr, res->ai_addrlen)== 0 ){ 
      break;
      }

   perror("connecting stream socket");

   close(fd);

   } 
   while( (res=res->ai_next) != NULL );

   freeaddrinfo(ressave);

   if ( res == NULL ){
      return -1;
      }

   return fd;
}

/**
 * argv[1] ip or name
 * argv[2] port or portName
 *
 */
int main(int argc, char *argv[]){

    int    fd;
    int    n;
    char   buf[1024];
    char  *p;

    if (argc != 3){
       printf("kullanımı: %s ip_or_name port\n",argv[0]);
       return EXIT_FAILURE;
       } 

    fd= socket_connect(argv[1], argv[2]);
    if ( fd < 0 ){
       return EXIT_FAILURE;
       }

    fprintf(stdout, "bağlandı, %s:%s\n", argv[1], argv[2]);

    for(;;){

       n = read(fd, buf, sizeof(buf)-1);

       if ( n == 0 ){
          fprintf(stdout, "sunucu kapandı.\n");
          break;
          }

       if ( n < 0 ){
          perror("read()");
          break;
          }
          
       // Gelen verinin dibini kapat.
       buf[n]= 0;
       fprintf(stdout, "%s", buf);
       
       // Gelen veriyi geri gönder.
       for(p= buf; *p != '\0'; p++){
          *p= toupper(*p);
          }

       if ( write(fd, buf, n) != n ){  // hata nedir?
          perror("write()");
          break;
          }

       }  // while 


    if ( close(fd) == -1 ){
       perror("close()");
       }

    fprintf(stdout, "tcp client bitti.\n");

    return EXIT_SUCCESS;
}
