/**
 * prog2.c
 *
 * Tek bağlantı kabul eden, iteratif tcp/ip server.
 *
 */
#include <stdio.h>
#include <stdlib.h>  
#include <string.h>  
#include <sys/socket.h>
#include <arpa/inet.h> 
#include <unistd.h>   
 
int main(int argc , char *argv[]){

   int  server_fd;
   int  client_fd;
   int  addr_len;
   char buf[256];
   int  n;
   int  port;

   struct sockaddr_in client;
   struct sockaddr_in server;

   if ( argc != 2 ){
      fprintf(stderr, "kullanımı: %s port\n", argv[0]);
      return EXIT_FAILURE;
      }

   // Soket kur.
   server_fd= socket(AF_INET , SOCK_STREAM , 0);

   if (server_fd == -1){
      perror("socket()");
      return EXIT_FAILURE;
      }
   
   port= atoi(argv[1]);

   // Nereden dinleyecek?
   server.sin_family     = AF_INET;
   server.sin_addr.s_addr= INADDR_ANY; // 0.0.0.0
   server.sin_port       = htons(port);
    
   if ( bind(server_fd, (struct sockaddr *)&server , sizeof(server)) < 0){
      perror("bind failed. Error");
      return EXIT_FAILURE;
   }
    
   // Pasif hale getir.
   listen(server_fd, 5);
   
   for(;;){

      // Bağlantı bekle.
      fprintf(stdout, "bağlantı bekliyorum, %d\n", port);
  
      addr_len= sizeof(struct sockaddr_in);
       
      // connect() gelene kadar bloklanır.
      client_fd= accept(server_fd, (struct sockaddr *)&client, (socklen_t*)&addr_len);
  
      if (client_fd < 0){
         perror("accept failed");
         return EXIT_FAILURE;
         }
  
      fprintf(stdout, "bağlantı kabul edildi, %s:%d\n", 
                      inet_ntoa(client.sin_addr), ntohs(client.sin_port));
       
      // celint'dan gelenleri ekrana yaz.
  
      for(;;){
  
         n= read(client_fd, buf, sizeof(buf)- 1);
  
         if ( n == 0 ){
            fprintf(stdout, "bağlantı kesildi.\n");
              close(client_fd);
              break;
            }
  
         if ( n < 0 ){
            perror("read()");
              close(client_fd);
              break;
            }
  
         buf[n]= '\0';
         fprintf(stdout, "%s", buf);
  
         }

       } // for ;;
     
    return EXIT_SUCCESS;
}

