/* prog3.c 
 *
 * getservbyname() örneği
 *
 * port numarasının elde edilmesi
 * /etc/services dosyasını okur
 *
 * MT-safe değil, addrinfo kullan!
 *
 * Örnek:
 *
 * $ ./prog4 https tcp
 * name:https   port:443   protocol:tcp
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>

int main(int argc, char *argv[]){

   struct servent *serv;

   if (argc != 3) {
      fprintf(stderr, "kullanımı: %s service-name protocol-name\n", argv[0]);
      return EXIT_FAILURE;
      }

   serv= getservbyname(argv[1], argv[2]);
 
   if (serv == NULL) {
      printf("service %s not found for protocol %s\n", argv[1], argv[2]);
      return EXIT_FAILURE;
      }

   fprintf(stdout, "name:%s   port:%d   protocol:%s\n",
             serv->s_name,
	     ntohs(serv->s_port),
	     serv->s_proto
	  );

   return EXIT_SUCCESS;
}

