/**
 * tcp client
 *
 * stdin'den okunan satırı sunucuya gönderir.
 * Sunucudan geleni stdout'a yazar.
 * Eski yöntem kullanılmıştır.
 * Sadece IP v4 için geçerlidir.
 *
 */
#include <stdio.h>

#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <ctype.h>

#include <sys/socket.h>
#include <sys/types.h>
#include <arpa/inet.h> 

/**
 * argv[1] ip or name
 * argv[2] port or portName
 * 
 */
int main(int argc, char *argv[]){

   struct sockaddr_in server_addr;
   int    fd;
   int    n;
   char   buf[256];
   char  *hostname;
   int    port;
   struct hostent *server;

   if (argc != 3){
      printf("kullanımı: %s ip_or_name port\n",argv[0]);
      return EXIT_FAILURE;
      } 

   hostname= argv[1];

   // hostname var mı bak? 
   server = gethostbyname(hostname);

   if (server == NULL){
      fprintf(stderr,"%s bulunmadı.\n", hostname);
      return EXIT_FAILURE;
      }

   port= atoi(argv[2]);
  
   // Boş soket kur.
   fd = socket(AF_INET, SOCK_STREAM, 0);
   if ( fd < 0){
      perror("socket()");
      return EXIT_FAILURE;
      }

   // Sunucu adresini kur.
   server_addr.sin_family = AF_INET;
   server_addr.sin_port = htons(port);
   bcopy((char *)server->h_addr, (char *)&server_addr.sin_addr.s_addr, server->h_length);

   // Bağlan.
   if ( connect(fd, (struct sockaddr *)&server_addr, sizeof(server_addr)) < 0){
      perror(hostname);
      return EXIT_FAILURE;
      }

   fprintf(stdout, "bağlandı, %s:%d\n", hostname, port);

   for(;;){

      // Satır oku.
      if ( fgets(buf, sizeof(buf), stdin) == NULL ){
         break;
         }

      // Satırı sunucuya gönder.
      if ( write(fd, buf, strlen(buf)) == -1 ){ 
         perror("write()");
         break;
         }

      // Yanıtı bekle.
      n = read(fd, buf, sizeof(buf)-1);

      if ( n == 0 ){
         fprintf(stdout, "sunucu kapandı.\n");
         break;
         }

      if ( n < 0 ){
         perror("read()");
         break;
         }
         
      // Gelen verinin dibini kapat ve göster.
      buf[n]= 0;
      fprintf(stdout, "%s", buf);

      }  // for;;


   if ( close(fd) == -1 ){
      perror("close()");
      }

   fprintf(stdout, "tcp client bitti.\n");

   return EXIT_SUCCESS;
}

