/**
 * prog1.c
 *
 * uevent dinler.
 * Gelen bilgileri stdout'a yazar.
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <linux/netlink.h>
#include <sys/socket.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>

int main(int argc, char *argv[]){

   unsigned int       len;
   unsigned int       i;
   int                res;
   int                fd;
   char               buf[4096];
   struct sockaddr_nl nls;  // net link socket
   char               c;

   fd= socket(PF_NETLINK, SOCK_RAW, NETLINK_KOBJECT_UEVENT);

   if (fd == -1){
      return EXIT_FAILURE;
      }

   memset(&nls, 0, sizeof(nls));

   nls.nl_family= AF_NETLINK;
   nls.nl_pid   = getpid();
   nls.nl_groups= 1;

   res = bind(fd, (struct sockaddr *)&nls, sizeof(nls));

   if (res == -1){
      return EXIT_FAILURE;
      }

   for(;;){
      len= recv(fd, buf, sizeof(buf), 0);

      for(i= 0; i< len; i++){

         c= buf[i];

         if (c == '\0') {
            fprintf(stdout, "\\0\n");
            continue;
            } 
         
         if ( isprint(c) ){
            fprintf(stdout, "%c", c);
            continue;
            } 
         
         fprintf(stdout, "0x%02X", c);

         } // for i

       fprintf(stdout, "\n");

   } // for

   if ( close(fd) == -1 ){
      perror("close()");
      return EXIT_FAILURE;
      }

   return 0;
}
