/**
 * prog1.c
 *
 * unix domain client
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>

#define SOCKET_PATH "echo_socket"

int main(int argc, char *argv[]){

    char buf[256];
    int  len;
    int  s;
    int  n;

    struct sockaddr_un remote;

    s= socket(AF_UNIX, SOCK_STREAM, 0);

    if ( s == -1 ) {
       perror("socket");
       return EXIT_FAILURE;
       }

    /*
     * struct sockaddr_un {
     *     unsigned short sun_family;  
     *     char sun_path[108];
     *     }
     *
     */
    remote.sun_family = AF_UNIX;
    strcpy(remote.sun_path, SOCKET_PATH);

    len= strlen(remote.sun_path)+ sizeof(remote.sun_family);

    if ( connect(s, (struct sockaddr *)&remote, len) == -1) {
       perror("connect()");
       return EXIT_FAILURE;
       }

    fprintf(stdout, "%s sunucusuna bağlandım.\n", SOCKET_PATH);

    for(;;){

       fprintf(stdout, " > ");

       if ( fgets(buf, sizeof(buf), stdin) == NULL ){
          break;
          }

       if (send(s, buf, strlen(buf), 0) == -1) {
          perror("send()");
          break;
          }

        n= recv(s, buf, sizeof(buf)- 1, 0);

        if ( n < 0 ){
           perror("recv()");
           break;
           }

        if ( n == 0 ){
           fprintf(stdout, "sunucu kapandı.\n");
           break;
           }

        buf[n] = '\0';
        fprintf(stdout, "%s", buf);

        } // for ;;

    if ( close(s) == -1 ){
       perror("close()");
       }

    return EXIT_SUCCESS;
}

