/**
 * prog2.c
 *
 * unix domain server
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>

#define SOCKET_PATH "echo_socket"

int main(int argc, char *argv[]){

    int client_fd;
    int s;
    int len;
    int n;
    struct sockaddr_un local, remote;
    char buf[256];
    socklen_t t;
    char *p;

    if ((s = socket(AF_UNIX, SOCK_STREAM, 0)) == -1) {
       perror("socket");
       return EXIT_FAILURE;
       }

    local.sun_family = AF_UNIX;
    strcpy(local.sun_path, SOCKET_PATH);

    unlink(local.sun_path);

    len = strlen(local.sun_path) + sizeof(local.sun_family);

    if ( bind(s, (struct sockaddr *)&local, len) == -1) {
       perror("bind");
       return EXIT_FAILURE;
       }

    if ( listen(s, 5) == -1){
       perror("listen");
       return EXIT_FAILURE;
       }

    for(;;) {
       fprintf(stdout, "%s üzerinden bağlantı bekliyorum.\n", SOCKET_PATH);

       t= sizeof(remote);
       client_fd= accept(s, (struct sockaddr *)&remote, &t);

       if ( client_fd == -1 ){
          perror("accept");
          break;
          }

       fprintf(stdout, "bağlantı kabul edildi.\n");

       for(;;){

          n= recv(client_fd, buf, sizeof(buf)- 1, 0);

          if (n == 0){
             fprintf(stdout, "bağlantı kapandı.\n");
             break;
             }

          if (n < 0){
             perror("recv()");
             break;
             }

          buf[n]= '\0';
          fprintf(stdout, "%s", buf);

          for(p= buf; *p != '\0'; p++){
             *p= toupper(*p);
             }

          if ( send(client_fd, buf, n, 0) < 0) {
             perror("send");
             break;
             }

          } // for;;

        if ( close(client_fd) == -1 ){
           perror("close()");
           }

        } // for ;;

    return EXIT_SUCCESS;
}

